--MR : since trailer are not "square filled", with "mr", we can set a filling capacity different from the "DIN capacity"
Fillable.mrLoad = function(self, savegame)	
	if self.mrIsMrVehicle and self.fillUnits then
		local i=0;
		while true do
			local key = string.format("vehicle.fillUnits.fillUnit(%d)", i);
			if not hasXMLProperty(self.xmlFile, key) then
				break;
			end
			local fillUnitIndex = i+1;
			
			if self.fillUnits[fillUnitIndex] then		
				self.fillUnits[fillUnitIndex].mrDINcapacity = self.fillUnits[fillUnitIndex].capacity; --backup the DIN capacity
				local fillVolumeCapacity = Utils.getNoNil(getXMLFloat(self.xmlFile, key .. "#mrFillVolumeCapacity"), self.fillUnits[fillUnitIndex].capacity);--the capacity parameter = DIN capacity. Here, we want the real capacity corresponding to what we see in game when the trailer is full. (the trailer is never "squared" filled, and so, the real capcity is diffrent from the DIN capacity
				self.fillUnits[fillUnitIndex].capacity = fillVolumeCapacity;			
			end		
			i=i+1;		
		end	
	end
	
	--load the mrCOMtransWithMass parameter from the xml
	local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.fillMassNode#mrCOMtransWithMass"));
	if x ~= nil and y ~= nil and z ~= nil then
		--print("test - y="..tostring(y));
		self.mrCOMtransWithMass = {x, y ,z};
	end
	self.mrFillMassComponent = nil;
	for _, component in pairs(self.components) do
		if component.node == self.fillMassNode then
			self.mrFillMassComponent = component;
			--print("test2 - self.mrFillMassComponent="..tostring(self.mrFillMassComponent) .. " - com y = "..tostring(self.mrFillMassComponent.centerOfMass[2]));
		end
	end
	self.mrLastCOMchangeMass = 0;
	
end
Fillable.load = Utils.appendedFunction(Fillable.load, Fillable.mrLoad);


--update the center of gravity according to the current "fillLevel mass"
Fillable.mrUpdateTick = function(self, dt)
	
	--print("test 0 - calling mrSetFillLevel");

	if self.isServer and self.mrIsMrVehicle and not self.mrVehicleIsStill and self.fillMassNode ~= nil then
		if self.mrFillMassComponent and self.mrCOMtransWithMass then
			--check currentMass against mass when last time we set the center of mass
			if self.currentMass~=self.mrLastCOMchangeMass then			
				local cargoMass = 0;
				for i,fillUnit in pairs(self.fillUnits) do
					if fillUnit.currentFillType ~= nil and fillUnit.currentFillType ~= FillUtil.FILLTYPE_UNKNOWN then
						local desc = FillUtil.fillTypeIndexToDesc[fillUnit.currentFillType];
						cargoMass = cargoMass + (fillUnit.fillLevel * desc.massPerLiter);
					end
				end	
				--print("test3 - new com y = " .. self.mrFillMassComponent.centerOfMass[2]+self.mrCOMtransWithMass[2]*cargoMass);
				setCenterOfMass(self.fillMassNode, self.mrFillMassComponent.centerOfMass[1]+self.mrCOMtransWithMass[1]*cargoMass, self.mrFillMassComponent.centerOfMass[2]+self.mrCOMtransWithMass[2]*cargoMass, self.mrFillMassComponent.centerOfMass[3]+self.mrCOMtransWithMass[3]*cargoMass);
				self.mrLastCOMchangeMass = self.currentMass;
			end
		end
	end

end
Fillable.updateTick = Utils.appendedFunction(Fillable.updateTick, Fillable.mrUpdateTick);