--************************************************************************************************************************************************************	
--base game = the player feels forced to use the sprayer at the max speed possible to minimize the fertilizer usage
--MR : as IRL, the implement uses a system to regulate the outpout function of the speed of the vehicle
Sprayer.mrGetLitersPerSecond = function(self, superfunc, fillType)
	if not self.mrIsMrVehicle then return superfunc(self, fillType); end
	
	local scale = Utils.getNoNil(self.sprayUsageScale.fillTypeScales[fillType], self.sprayUsageScale.default)
	local litersPerSecond = 1

	local sprayTypeIndex = Sprayer.fillTypeToSprayType[fillType]
	if sprayTypeIndex ~= nil then
		local spray = Sprayer.sprayTypeIndexToDesc[sprayTypeIndex]
		if spray ~= nil then
			litersPerSecond = spray.litersPerSecond
		end
	end

	--print("test sprayer - self.speedLimit="..tostring(self.speedLimit) .. " - width="..tostring(self.sprayUsageScale.workingWidth).." - litersPerSecond="..tostring(litersPerSecond));
	
	--return scale * litersPerSecond * self.speedLimit * self.sprayUsageScale.workingWidth
	local speedFx = math.max(0.1/self.speedLimit, self.lastSpeedReal*3600);
	return scale * litersPerSecond * self.sprayUsageScale.workingWidth * speedFx;
end
Sprayer.getLitersPerSecond = Utils.overwrittenFunction(Sprayer.getLitersPerSecond, Sprayer.mrGetLitersPerSecond);